﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.IdentityModel.Claims;
using System.Threading;
using System.Collections;
using System.Diagnostics; 

namespace LoginDemo
{
    public partial class _Default : System.Web.UI.Page
    {
        protected Hashtable _Claims = new Hashtable();
        protected Hashtable _Friends = new Hashtable();
        protected string _Hometown;

        protected void Page_Load(object sender, EventArgs e)
        {

            ParseClaims();
            if (!Page.IsPostBack)
            {
                GetFriends();
            }
        }

        /// <summary>
        /// Claims from FB via AppFabric ACS
        /// 
        /// :Claims:
        /// http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier-568657577
        /// http://schemas.microsoft.com/ws/2008/06/identity/claims/expiration-2010-12-09T21:00:00.2500923Z
        /// http://schemas.xmlsoap.org/ws/2005/05/identity/claims/emailaddress-jofultz@hotmail.com
        /// http://schemas.xmlsoap.org/ws/2005/05/identity/claims/name-Joseph Fultz
        /// http://www.facebook.com/claims/AccessToken-170143639685664|2.sQspIWuLsw8KibCLXJaGOQ__.3600.1291928400-568657577|hB_hIpND8Fxh9rEHbs8qtT-zs-g
        /// http://schemas.microsoft.com/accesscontrolservice/2010/07/claims/identityprovider-Facebook-170143639685664
        ///
        /// </summary>
        protected void ParseClaims()
        {
            string username = default(string);
            username = Page.User.Identity.Name;

            IClaimsPrincipal Principal = (IClaimsPrincipal) Thread.CurrentPrincipal;
            IClaimsIdentity Identity = (IClaimsIdentity) Principal.Identity;

            foreach (Claim claim in Identity.Claims)
            {
                string[] ParsedClaimType = claim.ClaimType.Split('/');
                string ClaimKey = ParsedClaimType[ParsedClaimType.Length - 1];

                _Claims.Add(ClaimKey, claim.Value);
            }             
        }

        protected void GetFriends()
        {

            _Friends = FBHelper.GetFBFriends((string)_Claims["AccessToken"]);
            this.ListBox1.DataSource = _Friends;
            ListBox1.DataTextField = "value";
            ListBox1.DataValueField = "key";

            ListBox1.DataBind();

        }

        protected void ListBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            Debug.WriteLine(ListBox1.SelectedValue.ToString());
            Hashtable FriendInfo = FBHelper.GetFBFriendInfo((string)_Claims["AccessToken"], ListBox1.SelectedValue.ToString());
            GridView1.DataSource = FriendInfo;
            GridView1.DataBind();

            try
            {
                Dictionary<string, object> HometownDict = (Dictionary<string, object>) FriendInfo["hometown"];
                _Hometown = HometownDict["name"].ToString();
                
            }
            catch (Exception ex)
            {
                _Hometown = "";//Not Specified";
            }
        }
    }
}
